require File.dirname(__FILE__) + '/../test_helper'
require 'quickvote_controller'

class ActionController::TestSession
  def session_id
    # Override this so we can set session ID
    # pass in the 'test_session_id' session variable to override default
    (@session and @session['test_session_id'])  or "12345678"
  end
end
# Re-raise errors caught by the controller.
class QuickvoteController; def rescue_action(e) raise e end; end

class QuickvoteControllerTest < Test::Unit::TestCase
  def setup
    @controller = QuickvoteController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  # Replace this with your real tests.
  def test_index
    get :index
    assert_response 302
  end

  def test_create_quickvote
    post(:create, {'commit' =>"Create Quickvote", 'quickvote' =>{'name' =>"variable", 'description' =>"Favorite variable."}}, nil, {:candlist=>["foo", "bar", "foobar"]})
    assert_template "quickvote/success"
    get :index, { 'ident' => "variable"}
    assert_response :success
  end

  def test_create_quickvote_badname
    post(:create, {'commit' => "Create Quickvote", 'quickvote' => {'name' => "has a space", 'description' => "Foobar"}}, nil, {:candlist => ["foo", "bar", "foobar"]})
    assert_template "quickvote/create"
  end

  def test_create_quickvote_dupe_candidate
    post(:create, {'commit' => "Create Quickvote", 'quickvote' => {'name' => "has a space", 'description' => "Foobar"}}, nil, {:candlist => ["foo", "bar", "bar",  "foobar"]})
    assert_template "quickvote/create"
  end
  
  def test_get_quickvote_nonexistent
    get :index, { 'ident' => "idontexist" }
    assert_redirected_to :controller => 'site'
  end
end
